import React from 'react';
import ParameterControl from './ParameterControl';
import ExtendableContainer from '../../base/ExtendableContainer';

import Logger from '../../../systems/Logger';
import Module from '../../Module';


Object.defineProperty(Object.prototype, "makeArray", {
	enumerable: false,
	value: (obj) => {
		let array = [];
		for(var key in obj) {
			array.push(obj[key]);
		}
		return array;
	}
});
//import './ModulesList.css';
class ModulesList extends Module {
	constructor(props) {
		super(props);
		this.state = {
			modules: []
		};
		//console.log(props.list);
	}

	componentWillReceiveProps() {
		this.refresh();
	}
	componentDidMount() {
		super.componentDidMount();
		this.refresh();
	}

	parseModules(modules) {
		let mods = modules.map((m) => m.Category + "/" + m.name);
		let result = {'Unordered':[]};
		mods.forEach((value, index) => {
			let names = value.split('/');
			let temp = result;
			for (let i=0;i<names.length-1;i++) {
				if(!temp[names[i]])
					temp[names[i]] = {};
				temp = temp[names[i]]; 
			}
			if(!temp.items)
				temp.items = [];
			temp.items.push(names[names.length-1]);
		})
		console.log("ModuleStructure: " , result);
		return result;
	}

	makeFolder(dictionary) {
		let res = [];
		for(var key in dictionary) {
			if(key === 'items') {
				for(var i in dictionary[key]) {
					console.log(dictionary[key][i])
					res.push(
						<ParameterControl className={this.props.controlClassName} module={this.props.list[dictionary[key][i]]} name={i} key={i}/>
					);
				}
				continue;
			}
			res.push(
				<ExtendableContainer header={key} key={key} className={this.props.className}>
					{this.makeFolder(dictionary[key])}
				</ExtendableContainer>
			);
		}
		return res;
	}

	refresh() {
		let modules = Object.makeArray(this.props.list) || [];
		let array = [];

		let dictionary = this.parseModules(modules);
		console.log(dictionary);
		let mods = this.makeFolder(dictionary);
		// let folders = Object.keys(modules).reduce((a,b) => {
		// 	a[modules[b].Category] = [...(a[modules[b].Category] || []), modules[b]];
		// 	return a;
		// }, {});
		
		this.setState({
			modules: mods,
			folders: []
		});
	}

	render() {
		return this.state.modules;
	}
}

export default ModulesList;