import React from 'react';
import ExtendableContainer from '../../base/ExtendableContainer';
import InputField from '../../base/InputField';

import Logger from '../../../systems/Logger';

import Module from '../../Module';
import ModuleSystem from '../../../systems/ModuleSystem';

//import './ParameterControl.css';

class ModuleCreation extends Module {

	constructor(props) {
		super(props);
		this.state = {
		};
		this.model = this.createInputs(props.inputs);
	}

	

	render() {
		return <div>
			
		</div>;
	}
}

class ParameterControl extends Module {
	constructor(props) {
		super(props);
		this.state = {
		};
		this.model = this.createInputs(this.props.module.Inputs);
	}

	createInputs(inputs) {
		let res = [];
		for(let key in inputs) {
			let data = inputs[key];
			this.state[key] = data.defaultValue;
			res.push(<InputField name={key} metadata={data} key={key} onChange={(v) => this.setState({
				[key]: v
			})}/>);
		}
		return res;
	}

	createInstance(e) {
		if(e)
			e.preventDefault();
		let inputs = {};
		for(var i in this.state) {
			inputs[i] = {name: i, value:this.state[i]};
		}
		let nprops = {
			ctor: this.props.module.name,
			children: [],
			id: '123', //random
			inputs: inputs,
			outputs: {}
		}

		let module = nprops;
		return module;
	}

	render() {
		let OM = Module.OutputMarker;
		let header = <OM module={this.createInstance()} text={this.props.module.name} />;
		return <div className={this.props.className + ' ParameterControl'}>
			{header}
		</div>;
	}
}

export default ParameterControl;