import React from 'react';
import Module from '../Module';

const UNIT_REGEX = /[A-Z]/g;
class Container extends Module {
	constructor(props) {
		super(props);
		this.state = {
			children: []
		};
		this.mode = props._mode;
	}

	render() {
		let bg = this.background.value || '',
		  w    = this.width.value ? this.width.value : 'auto',
		  h    = this.height.value ? this.height.value : 'auto';
		return <div className={`container ${Object.getPrototypeOf(this) === Container.prototype ? this.props.className || this.ClassName.value : ''}`} style={{background:bg, width: w, height: h, padding: ""+this.Padding.value, ...this.props.style}}>
			{super.render()}
		</div>;
	}
}

Container.EditPosition = "top-left"
Container.Inputs = {
	// ADD Extensions
	// ...ExtendedModule.Inputs
	...Module.Inputs,
	ClassName: {
		type: Module.Types.Text,
		required: false,
		comment: "ClassName"
	},
	width: {
		type: Module.Types.Text,
		required: true,
		defaultValue: 'auto'
	},
	height: {
		type: Module.Types.Text,
		required: false,
		defaultValue: "auto",
		comment: "Setting this comment here to show the power!"
	},
	background: {
		type: Module.Types.Text,
		required: false,
		comment: "Setting bg color!"
	},
	Padding: {
		type: Module.Types.Text
	}
}
Container.Outputs = {
	custom: {

	}
}

Container.Category = "Basic";

export default Container;