import React from 'react';
import Module from '../Module';
import Container from './Container';

import './ExtendableContainer.css';

class ExtendableContainer extends Module {
	constructor(props) {
		super(props);
		this.state = {
			extended: false
		};
	}

	toggle(e) {
		this.setState({ extended: !this.state.extended });
	}
	render() {

		let cprops = {};
		for(var i in Container.Inputs){
			cprops[i] = this[i].value;
		}
		console.log(this.props, this.header.value);
		return !this.props.inverse ? 
			<div key={'openIt' + this.header.value} className={`ExtendableContainer ${Object.getPrototypeOf(this) === ExtendableContainer.prototype ? this.props.className : ''}`} style={this.props.style}>
				<div onClick={() => this.toggle()} className="ExtendableContainerHeader">{this.header.value || 'asd' }</div>
				<div className={`ExtendableContainerContent ${this.state.extended ? 'show': ''}`}>
					<Container {...cprops} style={{padding:3}}>
						{this.props.children || ''}
					</Container>
				</div>
				{super.render(false)}
			</div>
			:
			<div key={'closeIt'  + this.header.value} className={`ExtendableContainer ${Object.getPrototypeOf(this) === ExtendableContainer.prototype ? this.props.className : ''}`} style={this.props.style}>
				<div className={`ExtendableContainerContent ${this.state.extended ? 'show': ''}`}>
					{super.render()}
				</div>
				<div onClick={() => this.toggle()} className="ExtendableContainerHeader">{this.header.value}</div>
				{super.render(false)}
			</div>;
	}
}

ExtendableContainer.Inputs = {
	...Container.Inputs,
	header: {
		type: Module.Types.Text,
		defaultValue: "Header"
	}
}

ExtendableContainer.Category = "Basic";
export default ExtendableContainer;