import React from 'react';
import Module from '../Module';

const UNIT_REGEX = /[A-Z]/g;
class FluidContainer extends Module {
	constructor(props) {
		super(props);
		this.state = {
			children: [],
			text: this.text.value || ''
		};
		this.mode = props._mode;

		this.text.onUpdate((text) => {
			this.setState({text});
		});
	}

	render() {
		let bg = this.background.value || '',
		  text = this.text.value || '',
		  w    = this.width.value ? this.width.value : 'auto',
		  h    = this.height.value ? this.height.value : 'auto';
		return <div className={` ${Object.getPrototypeOf(this) === FluidContainer.prototype ? (this.ClassName.value + " " + this.props.className) || '' : ''}`} style={{background:bg, width: w, height: h, ...this.props.style}}>
			{this.state.text}
			{super.render()}
		</div>;
	}
}

FluidContainer.EditPosition = "top-left"
FluidContainer.Inputs = {
	// ADD Extensions
	// ...ExtendedModule.Inputs
	...Module.Inputs,
	width: {
		type: Module.Types.Text,
		required: true,
		defaultValue: 'auto'
	},
	height: {
		type: Module.Types.Text,
		required: false,
		defaultValue: "auto",
		comment: "Setting this comment here to show the power!"
	},
	background: {
		type: Module.Types.Text,
		required: false,
		comment: "Setting bg color!"
	},
	text: {
		type: Module.Types.Text,
		required: false,
		comment: "Text for Fluidcontainer"
	},
	ClassName: {
		type: Module.Types.Text,
		required: false
	}
}
FluidContainer.Outputs = {
	custom: {

	}
}

FluidContainer.Category = "Basic";

export default FluidContainer;