import React from 'react';
import Module from '../Module';

import './Image.css';

class Image extends Module {
	constructor(props) {
		super(props);
		this.state = {
			src: this.src.value
		}
		this.src.onUpdate((src) => this.setState({src}));
	}

	render() {
		return [<div key={1} style={{backgroundImage: `url(${this.state.src})`}} className="adaptableImage"></div>, super.render()];
	}
}

Image.EditPosition = "center";
Image.Inputs = {
	// ADD Extensions
	// ...ExtendedModule.Inputs
	src: {
		type: Module.Types.Link,
		required: true,
		defaultValue: 'https://xsisupport.files.wordpress.com/2015/02/no_icon_rgb.jpg'
	}
}


Image.Category = "Basic";
export default Image;