import React from 'react';
import Module from '../Module';

class Text extends Module {
	constructor(props) {
		super(props);
		this.state = {
			edit: false
		}
		this.input.onUpdate((e) => this.forceUpdate());
	}

	edit() { 
		if(this._mode === "normal" || this._mode === "admin") {
			this.setState({
				edit:true
			});
		}
	}

	change(value) {
		this._change('text', value, this.text);
		this.setState({
			edit:false
		})
	}

	render() {
		console.log("TEXT", this.text.value)
		return this.state.edit ?
						  <div style={{...this.props.style}} className={this.props.className + " Text"} style={{fontSize: parseInt(this.size.value), color: this.color.value}}>
							<textarea onBlur={(e) => this.change(e.target.value)} defaultValue={this.text.value}></textarea>
							{super.render()}
						  </div>
						: <div onClick={() => this.edit()} style={{...this.props.style}} className={this.props.className + " Text"} style={{fontFamily: this.family.value, fontSize: parseInt(this.size.value), color: this.color.value}}>
							{this.input.value}
							{this.text.value}
							{super.render()}
						  </div>;
		
	}
}

Text.Inputs = {
	text: {
		type: Module.Types.Text,
		defaultValue: "DefaultText"
	},
	size: {
		type: Module.Types.Number,
		defaultValue: "14"
	},
	family: {
		type: Module.Types.Text,
		defaultValue: "Arial"
	},
	color: {
		type: Module.Types.Text,
		defaultValue: "black"
	},
	input: {
		type: Module.Types.Link
	}
}

Text.Category = "Basic";
export default Text;