import React from 'react';

import Module from '../Module';

import Modules from '../index.js';


import { Row, Col } from 'react-materialize';

import './BasicLayout.css';



class BasicLayout extends Module {
	constructor(props) {
		super(props);

		this.ghost(this.getId() + "BLTOP");
		this.ghost(this.getId() + "BLLEFT");
		this.ghost(this.getId() + "BLRIGHT");
		this.ghost(this.getId() + "BLCONTENT");
		this.ghost(this.getId() + "BLNavbar", "Navbar");
		this.ModuleSystem.refresh();
	}

	ghost(id, ctor = "Container") {
		if(this.ModuleSystem.has(id))return;
		let module = {
			children: [],
			ctor: ctor,
			id: id,
			key: "key" + Math.random()
		}
		this.ModuleSystem.loadModule(module);		
	}

	render() {
		let { Container, Navbar } = Modules;
		let lmenusize = this.leftMenu.value;
		let rmenusize = this.rightMenu.value;
		let contentsize = 12 - lmenusize - rmenusize;
		return [<Container width="100%" className={'container'} key={'BL'}>
			<Row className={'BLtop'}>
				<Col s={12}>
					{this.ModuleSystem.render(this.getId() + "BLNavbar")}
				</Col>
			</Row>
			<Row className={'BLmain'}>
				<Col s={lmenusize} className={'BLLeftMenu'}>
					{this.ModuleSystem.render(this.getId() + "BLLEFT")}
				</Col>
				<Col s={contentsize} className={'BLContent'}>
					{this.ModuleSystem.render(this.getId() + "BLCONTENT")}
				</Col>
				<Col s={rmenusize} className={'BLRightMenu'}>
					{this.ModuleSystem.render(this.getId() + "BLRIGHT")}
				</Col> 
			</Row>
			<Row className={'BLfooter'}>
				<Col s={lmenusize}>
				asd
				</Col>
				<Col s={contentsize}>
				eqw
				</Col>
				<Col s={rmenusize}>
				123
				</Col> 
			</Row>
 			</Container>,
		super.render()];
	}
}
BasicLayout.EditPosition = 'top-center';
BasicLayout.Inputs = {
	// ADD Extensions
	// ...ExtendedModule.Inputs
	...Module.Inputs,
	leftMenu: {
		type: Module.Types.Number,
		required: true,
		defaultValue: 3
	},
	rightMenu: {
		type: Module.Types.Number,
		required: true,
		defaultValue: 3
	}
}

BasicLayout.Category = "Layout";

export default BasicLayout;