import React from 'react';

import Module from '../Module';

import Link from './Link.js';

class Breadcrumb extends Module {
	constructor(props) {
		super(props);
	}


	render() {
		let routes = this.RoutingSystem.getRoutesRegs();
		let route = this.RoutingSystem.getRoute();
		let url = route.url || '';
		let arr = [];
		for(var i in routes) {
			if(routes[i].reg.test(url)) {
				arr.push(routes[i]);
			}
		}

		let narr = arr.sort((a,b) => a.url.length - b.url.length);
		let res = narr.map((item, indx) => <li key={indx} className="breadcrumb-item"><Link link={item.id}>{this.RoutingSystem.getRouteName(item.id)}</Link></li>);
		return <div className={this.props.className + ' Breadcrumb '}>
			<nav aria-label="breadcrumb">
			  <ol className="breadcrumb">
			  {res}
			  </ol>
			</nav>
			{super.render()}
		</div>;
	}
}
Breadcrumb.EditPosition = 'top-center';
Breadcrumb.Category = "Layout";

export default Breadcrumb;