import React from 'react';
import Module from '../Module';

import User from '../../systems/services/User';

import Link from './Link.js';



import './Navbar.css';
class Navbar extends Module {
	constructor(props) {
		super(props);
		this.state = {
		}


	}

	render() {
		// 	</div>;
		return <nav className="navbar navbar-expand-md navbar-dark bg-dark">
				  	<a className="navbar-brand" href="#">
				     	<img src={this.logo.value} width="30" height="30" className="d-inline-block align-top" alt="" />
				    	{this.brand.value}
				    </a>
					<button className="navbar-toggler" type="button" data-toggle="collapse" data-target="#NAVID" aria-controls="NAVID" aria-expanded="false" aria-label="Toggle navigation">
				   		<span className="navbar-toggler-icon"></span>
				  	</button>
				  	<div className="collapse navbar-collapse" id="NAVID">
				    	<ul className="navbar-nav">
				    	{(this.headers.value || []).map((item,index) => {
							return <li className="nav-item active" key={index}>
								<Link link={this.links.value[index]} className='nav-link'>
								{item}
								</Link>
							</li>
						})}	
				    	</ul>
				  	</div>
				  	{super.render(true)}
				</nav>;
	}
}

Navbar.EditPosition = "top-right";
Navbar.Inputs = {
	logo: {
		type: Module.Types.Text,
		defaultValue: '/logo.png'
	},
	brand: {
		type: Module.Types.Text,
		defaultValue: 'Bootstrap'		
	},
	headers: {
		type: Module.Types.Array,
		defaultValue: ['Home','Test','Contact'],
		arrType: Module.Types.Text
	},
	links: {
		type: Module.Types.Array,
		defaultValue: ['home','test','contact'],
		arrType: Module.Types.Text
	}
}

Navbar.Category = "Layout";

export default Navbar;