import React from 'react';
import Module from '../Module';

function checkIt(resp) {
    if ( parseInt(resp.status / 100, 10) === 2) {
        return resp;
    } else {
        throw resp;
    }
}

function catchIt(err) {
    if ( parseInt(err.status / 500, 10) === 5 ){
        return err;
    } else {
        return err;
    }
}

class APIService {
	constructor(baseURL) {
		this.baseURL = baseURL;
	}

	get(url) {
        url = this.baseURL + url;
        return window.fetch(url, {method: 'GET'}).then(checkIt).then((r) => r.json()).catch(catchIt);
    }

    post(url, body) {
        let urb = this.baseURL + url;
        return window.fetch(urb, {
            method: 'POST',
            headers: {
                'Content-Type':'application/json',
                'Token' : ''
            },
            body: JSON.stringify(body)
        }).then(checkIt).then((r) => r.json()).catch(catchIt);
    }
}

class API extends Module {
	constructor(props) {
		super(props);

		this.baseURL.onUpdate((v) => this.setAPI(v));
		this.setAPI(this.baseURL.value);
	}

	setAPI(v) {
		let temp = new APIService(v);
		this.api.set(temp);
	}


	render() {
		return super.render();
	}
}

API.Inputs = {
	baseURL: {
		type: Module.Types.Text,
		required: true,
		comment: "API URL",
		defaultValue: '/'
	}
}
API.Outputs = {
	api: {
	}
}

API.Category = "Services";

export default API;