import React from 'react';
import Module from '../Module';

import Extendable from '../base/ExtendableContainer';

import {InputMarker} from '../ModuleUtilities';

import { FontAwesomeIcon } from '@fortawesome/react-fontawesome'


import './ModuleServiceInfo.css';

class ModuleServiceInfo extends Module {
	constructor(props) {
		super(props);
		this.state = {
			modid: '', 
			route: ''
		}
	}

	loadModule(mod) {
		let answer = prompt("Module ID: ");
		if(!answer) return;
		mod.id = answer;
		this.ModuleSystem.loadModule(mod);
		this.CoreSystem.refresh(true);
	}

	removeModule(mod) {
		this.ModuleSystem.remove(mod);
		this.CoreSystem.refresh();
		this.forceUpdate();
	}

	render() {
		let modules = this.ModuleSystem.getModules();
		// console.log(modules);
		return <div className={'ModuleServiceInfo'}>
			<div className='row'>
				{this.__renderID()}
			</div>
			<div className='row'>
				<div className='col s3'>
					Modules 
				</div>
				<div className='col'>
					{modules.length}
					<InputMarker onDrop={(mod) => this.loadModule(mod)} />
				</div>
			</div>
			<div className="row ModuleList white z-depth-1">
			{modules.map((mod, key) => 
				<div className="col s6 text-left" style={{overflow:'hidden'}} key={mod.id}>
					<div style={{display: 'inline-block'}}>
					<FontAwesomeIcon icon="eraser" onClick={() => this.removeModule(mod.id)}/>
					</div>
					<div style={{display: 'inline-block', width: 48}}>
					{mod.id}
					</div>
				</div>
			)}
			</div>
			{super.render()}
		</div>;
	}
}
ModuleServiceInfo.Category = "Services";

export default ModuleServiceInfo;