import React from 'react';
import Module from '../Module';

import Extendable from '../base/ExtendableContainer';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome'

import {Table , TextInput as Input } from 'react-materialize';

import './RouterServiceInfo.css';

class RouterServiceInfo extends Module {
	constructor(props) {
		super(props);
		this.state = {
			modid: '', 
			route: '',
			routeName: ''
		}
	}

	removeRoute(modid, route) {
		this.RoutingSystem.removeRoute(modid, route);
		this.CoreSystem.refresh(true);
		this.forceUpdate();
	}

	render() {
		let routes = this.RoutingSystem.getRoutes();
		return <div className={''} >
			<div className='row'>
				{this.__renderID()}
			</div>
			<div className='row'>
				<div className='col s4'>
					Current View : 
				</div>
				<div className='col s8'>
					{this.RoutingSystem.getCurrentView()}
				</div>
			</div>


			<div className='row'>
				<Table className="white"  bordered hoverable={true} responsive={true}>
				  <thead>
					<tr>
				      <th></th>
				      <th>ModID</th>
				      <th>Route</th>
				      <th>Name</th>
				    </tr>
				  </thead>
				  <tbody>
					{routes.map((route, key) => 
						<tr key={route.route}>
							<td><FontAwesomeIcon icon="trash" onClick={() => this.removeRoute(route.id, route.route)}/></td>
							<td>{route.id}</td>
							<td>{route.route}</td>
							<td>{route.routeName}</td>
						</tr>
					)}	
					<tr>
						<td>
							<button onClick={() => {this.RoutingSystem.addRoute(this.state.route, this.state.modid, this.state.routeName); this.setState({route: '', modid: ''})}}>
							Add
							</button>
						</td>
						<td><input type="text" value={this.state.modid} onChange={(e) => this.setState({modid: e.target.value})}/></td>
						<td><input type="text" value={this.state.route} onChange={(e) => this.setState({route: e.target.value})}/></td>
						<td><input type="text" value={this.state.routeName} onChange={(e) => this.setState({routeName: e.target.value})}/></td>
					</tr>
				  </tbody>
				</Table>
			</div>
			{super.render()}
		</div>;
	}
}

RouterServiceInfo.Category = "Services";
export default RouterServiceInfo;