import React from 'react';
import Module from '../Module';

import './Card.css';

const UNIT_REGEX = /[A-Z]/g;
class Card extends Module {
	constructor(props) {
		super(props);
		this.state = {
			children: [],
			text: this.header.value || ''
		};
		this.mode = props._mode;
	}

	render() {
		let text = this.header.value || '',
		  w    = this.width.value ? this.width.value : 'auto',
		  h    = this.height.value ? this.height.value : 'auto',
		  img  = this.image.value;
		return <div className={`card shadow-sm ${Object.getPrototypeOf(this) === Card.prototype ? this.props.className || '' : ''}`} style={{width: w, height: h}}>
			{img ? <img class="card-img-top" src={img} alt="Card image cap"/> : ''}
			<div className="card-body">
				<div className="card-title">
					{text}
				</div>
				{super.render()}
			</div>
		</div>;
	}
}

Card.EditPosition = "center"
Card.Inputs = {
	// ADD Extensions
	// ...ExtendedModule.Inputs
	...Module.Inputs,
	width: {
		type: Module.Types.Number,
		required: true,
		defaultValue: 'auto'
	},
	height: {
		type: Module.Types.Number,
		required: false,
		defaultValue: "auto"
	},
	header: {
		type: Module.Types.Text,
		required: false,
		defaultValue: ""
	},
	image: {
		type: Module.Types.Text,
		required: false,
		defaultValue: ""	
	}
}

Card.Category = "theme"
export default Card;