import React from 'react';
import Module from '../Module';

import './Form.css';

const UNIT_REGEX = /[A-Z]/g;
class Form extends Module {
	constructor(props) {
		super(props);
		this.state = {
		};
		this.object.onUpdate((e) => this.forceUpdate());
	}


	submit(e) {
		e.preventDefault();
		this.formData.set(this.state);
		if(this.props.onSubmit)
			this.props.onSubmit(this.state);
		return false;
	}

	render() {
		let inputs = Object.keys(this.object.value || {}).map((key, index) => {
			this.state[key] = this.state[key] || this.object.value[key];
			return <div className="form-group" key={index}>
			    <label>{key}</label>
			    <input type="text" className="form-control" placeholder={key} onChange={(e) => this.setState({[key]: e.target.value})} value={this.state[key]} />
			  </div>;
		});
		return <div>
			<form className={`Form ${Object.getPrototypeOf(this) === Form.prototype ? this.props.className || '' : ''}`} onSubmit={(e) => this.submit(e)}>
			  	{inputs}
  				<button type="submit" className="btn btn-primary">{this.props.buttonText || "Submit"}</button>
  				{super.render()}
			</form>
		</div>;
	}
}

Form.EditPosition = "center"
Form.Inputs = {
	// ADD Extensions
	// ...ExtendedModule.Inputs
	...Module.Inputs,
	object: {
		type: Module.Types.Link,
		required: false
	}
}

Form.Outputs = {
	// ADD Extensions
	// ...ExtendedModule.Inputs
	formData: {
	}
}

Form.Category = "Theme";

export default Form;