import React from 'react';
import Logger from './Logger';

class Systems { 
	constructor() {
		this.CoreSystem = null;
		this.subSystems = {
			core: null
		};
		this.modules = {};
		this.services = {};
	}
	setCore(core) {
		this.subSystems.core = core;
		this.CoreSystem = core;
		core.LinkManager.disableCore();
		this.decorate('core', core.ModuleSystem);
		this.decorate('core', core.ServiceSystem);
		this.decorate('core', core.LinkManager);
		this.decorate('core', core.RoutingSystem);
		return core;
	}
	getCore() {
		return this.CoreSystem;
	}

	addSystem(core) {
		let id = core.id;
		if(!id){
			Logger.error("Cannot addSystem core.id is not defined!", core, id);
			return;
		}
		this.subSystems[id] = core;
		this.decorate(id, core.ModuleSystem);
		this.decorate(id, core.ServiceSystem);
		this.decorate(id, core.LinkManager);
		this.decorate(id, core.RoutingSystem);
	}
	
	getSystem(id) {
		return this.subSystems[id];
	}

	decorate(id, obj) {
		obj.CoreSystem = this.subSystems[id];
		obj.ModuleSystem = this.subSystems[id].ModuleSystem;
		obj.ServiceSystem = this.subSystems[id].ServiceSystem;
		obj.RoutingSystem = this.subSystems[id].RoutingSystem;
		obj.LinkManager = this.subSystems[id].LinkManager;
	}

	systemAdmin(id) {
		// ? 
		let LM = this.subSystems[id].LinkManager;
	}

	addService(ser) { this.services[ser.name] = ser; }
	addModule(mod) { this.modules[mod.name] = mod; }
	addServices(sers) { for(let i in sers)this.services[i] = sers[i]; }
	addModules(mods) { for(let i in mods)this.modules[i] = mods[i]; }
	
	
	getModules() { return this.modules; }
	getServices() { return this.services; }

}

export default new Systems();