import React from 'react';

function checkIt(resp) {
    if ( parseInt(resp.status / 100, 10) === 2) {
        return resp;
    } else {
        throw resp;
    }
}

function catchIt(err) {
    if ( parseInt(err.status / 100, 10) === 5 || parseInt(err.status / 100, 10) === 4 ){
        throw err;
    } else {
        return err;
    }
}

class API {
	constructor(baseURL) {
		this.baseURL = '';
	}

	setUrl(url) {this.baseURL = url} 

	get(url, token) {
        url = this.baseURL + url;
        return window.fetch(url, {
            method: 'GET',
            headers: {
                'token' : token
            }
        }).then(checkIt).then((r) => r.json()).catch(catchIt);
    }

    post(url, body, token) {
        let urb = this.baseURL + url;
        return window.fetch(urb, {
            method: 'POST',
            headers: {
                'Content-Type':'application/json',
                'token' : token
            },
            body: JSON.stringify(body)
        }).then(checkIt).then((r) => r.json()).catch(catchIt);
    }
}

export default new API();